Description

We need to access AuxDetGeometryCore via the auxdetgeometry service. At the same time, we need to access GeometryCore via
geometry service. My understanding is that the auxdetgeometry service has problems in this use case. What course of action is
recommended?

History

#1 - 07/08/2020 08:01 PM - Gianluca Petrillo
- Co-Assignees deleted (Adi Ashkenazi)

#2 - 07/13/2020 10:34 AM - Kyle Knoepfel

- Status changed from New to Feedback

What problems did you encounter while trying to use both in the same job? We are not aware of any issues.

#3 - 07/13/2020 04:13 PM - Gianluca Petrillo

That is because there is a poor-man synchronisation attempt between the two services.

One is a fork of the other, and both attempt to initialise a geometry representation from a GDML file.

Since this happens via ROOT... ¢a va sans dire. ROOT TGeoManager hooks gGeoManager (if | remember the name right), and g stands for "ROOT
loves g lobal state".

There was also the request at the time (LArIAT, | think) that AuxDetGeometry service could be loaded without Geometry service.

My dream at the time was to have a GeometrySource which managed the shared resource, and the other two services would interface with it as
needed... never happened.

#4 - 07/20/2020 10:33 AM - Kyle Knoepfel

Thanks, Gianluca, for the info. Chris, can you send us a FHiCL file, which would load both services according to your desired use case? That will
help us explore the entanglements and pursue a solution to any problems that arise.

#5 - 08/24/2020 10:28 AM - Kyle Knoepfel
- Priority changed from High to Normal
- Assignee set to Kyle Knoepfel

#6 - 01/28/2021 10:46 AM - Biswaranjan Behera

- Priority changed from Normal to High

Kyle Knoepfel wrote:
Thanks, Gianluca, for the info. Chris, can you send us a FHICL file, which would load both services according to your desired use case? That
will help us explore the entanglements and pursue a solution to any problems that arise.

Dear Kyle,

Sorry for the delay on replying back.

In /icarus/app/users/bbehera/devs/srcs/icarusalg/icarusalg/Geometry/geometry_icarus.fcl,
| have added these line in order to use AuxdetGeometry.

1. CRT Auxiliary detector service configuration
icarus_auxdetgeo: {

Name: "icarus_splitwires"

GDML: "icarus_complete_splitwire_newcrtgeo_channelmaptest_15Jan2021.gdml"
ROOT: "icarus_complete_splitwire_newcrtgeo_channelmaptest_15Jan2021.gdml"

}
icarus_auxdetgeometry_helper: {
service_provider: "CRTGeometryHelper"

}
1. geometry configuration bundle
icarus_crt_channelmapping_services: {
AuxDetGeometry: @local::icarus_auxdetgeo
AuxDetExptGeoHelperinterface: @local::icarus_auxdetgeometry_helper

} # icarus_crt_channelmapping_services

and my g4.fcl file is located here.
/icarus/app/users/bbehera/work/crt/chmap/g4.fcl

input to this fhicl file is located here: /icarus/app/users/bbehera/work/crt/chmap/gen.root

gdml file can be found in this location:
/icarus/app/users/bbehera/devs/srcs/icarusalg/icarusalg/Geometry/gdml/icarus_complete_splitwire_newcrtgeo_channelmaptest_15Jan2021.gdml
/icarus/app/users/bbehera/devs/srcs/icarusalg/icarusalg/Geometry/gdml/icarus_complete_splitwire_newcrtgeo_channelmaptest_15Jan2021_nowires.
gdml

Please let me know if | could provide more information.

Thank you.

With regards,
Bishu

#7 - 02/05/2021 06:29 PM - Gianluca Petrillo

| have taken a quick look at AuxDetGeometry. It seems that the functionality carried by it is not overwhelming...
| can imagine the possibility of transferring it into Geometry.
In fact, only two channel mapping methods (PositionToAuxDetSensitive() and PositionToAuxDetChannel()) are unique to AuxDetGeometry.

#8 - 02/08/2021 10:36 AM - Kyle Knoepfel
- Assignee deleted (Kyle Knoepfel)

Gianluca, your proposal sounds sensible. Are you willing to make a PR?

#9 - 02/22/2021 10:35 AM - Kyle Knoepfel

Gianluca, any progress or thoughts on this?

#10 - 03/15/2021 10:46 AM - Erica Snider

Gianluca??

#11 - 03/22/2021 10:28 AM - Kyle Knoepfel

We will schedule a meeting to discuss this issue (in particular) but also in the context of experiments' broader geometry needs.
